;--------------------------------------------------------------------
;  Asm09win 8080Sj[jbNEeXgR[h
;--------------------------------------------------------------------
          ORG       100H
;          .8080

MAX       EQU       256
MIN       EQU       -129      ;IF ASM, RANGE:0-255 AND MINUS NG
nn        EQU       1234H

;--------------------------------------------------------------------
;  TRANSFER 8BIT
;--------------------------------------------------------------------
          MOV       A, A
          MOV       A, B
          MOV       A, C
          MOV       A, D
          MOV       A, E
          MOV       A, H
          MOV       A, L

          MOV       B, A
          MOV       B, B
          MOV       B, C
          MOV       B, D
          MOV       B, E
          MOV       B, H
          MOV       B, L

          MOV       C, A
          MOV       C, B
          MOV       C, C
          MOV       C, D
          MOV       C, E
          MOV       C, H
          MOV       C, L

          MOV       D, A
          MOV       D, B
          MOV       D, C
          MOV       D, D
          MOV       D, E
          MOV       D, H
          MOV       D, L

          MOV       E, A
          MOV       E, B
          MOV       E, C
          MOV       E, D
          MOV       E, E
          MOV       E, H
          MOV       E, L

          MOV       H, A
          MOV       H, B
          MOV       H, C
          MOV       H, D
          MOV       H, E
          MOV       H, H
          MOV       H, L

          MOV       L, A
          MOV       L, B
          MOV       L, C
          MOV       L, D
          MOV       L, E
          MOV       L, H
          MOV       L, L

          MVI       A, MAX - 1
          MVI       B, MIN + 1
          MVI       C, MAX - 1
          MVI       D, MIN + 1
          MVI       E, MAX - 1
          MVI       H, MIN + 1
          MVI       L, MAX - 1

          MOV       A, M
          MOV       B, M
          MOV       C, M
          MOV       D, M
          MOV       E, M
          MOV       H, M
          MOV       L, M

          MOV       M, A
          MOV       M, B
          MOV       M, C
          MOV       M, D
          MOV       M, E
          MOV       M, H
          MOV       M, L

          MVI       M, MIN + 1
          LDAX      B
          LDAX      D
          LDA       nn
          STAX      B
          STAX      D
          STA       nn

;--------------------------------------------------------------------
;  TRANSFER 16BIT
;--------------------------------------------------------------------
          LXI       B, nn
          LXI       D, nn + 1
          LXI       H, nn + 2
          LXI       SP, nn + 3
          LHLD      nn + 4
          SHLD      nn + 5
          SPHL

;--------------------------------------------------------------------
;  EXCHANGE
;--------------------------------------------------------------------
          XCHG
          XTHL

;--------------------------------------------------------------------
;  STACK OPERATION
;--------------------------------------------------------------------
          PUSH      B
          PUSH      D
          PUSH      H
          PUSH      PSW

          POP       B
          POP       D
          POP       H
          POP       PSW

;--------------------------------------------------------------------
;  ROTATE
;--------------------------------------------------------------------
          RLC
          RAL
          RRC
          RAR

;--------------------------------------------------------------------
;  8BIT ARITHMETIC OPERATION
;--------------------------------------------------------------------
          ADD       A
          ADD       B
          ADD       C
          ADD       D
          ADD       E
          ADD       H
          ADD       L

          ADI       MAX - 1
          ADD       M

          ADC       A
          ADC       B
          ADC       C
          ADC       D
          ADC       E
          ADC       H
          ADC       L

          ACI       MIN + 1
          ADC       M

          SUB       A
          SUB       B
          SUB       C
          SUB       D
          SUB       E
          SUB       H
          SUB       L

          SUI       MAX - 1
          SUB       M

          SBB       A
          SBB       B
          SBB       C
          SBB       D
          SBB       E
          SBB       H
          SBB       L

          SBI       MIN + 1
          SBB       M

          INR       A
          INR       B
          INR       C
          INR       D
          INR       E
          INR       H
          INR       L
          INR       M

          DCR       A
          DCR       B
          DCR       C
          DCR       D
          DCR       E
          DCR       H
          DCR       L
          DCR       M

;--------------------------------------------------------------------
;  16BIT ARITHMETIC OPERATION
;--------------------------------------------------------------------
          DAD       B
          DAD       D
          DAD       H
          DAD       SP
          INX       B
          INX       D
          INX       H
          INX       SP
          DCX       B
          DCX       D
          DCX       H
          DCX       SP

;--------------------------------------------------------------------
;  LOGICAL OPERATION
;--------------------------------------------------------------------
          ANA       A
          ANA       B
          ANA       C
          ANA       D
          ANA       E
          ANA       H
          ANA       L
          ANI       MAX - 1
          ANA       M

          ORA       A
          ORA       B
          ORA       C
          ORA       D
          ORA       E
          ORA       H
          ORA       L
          ORI       MIN + 1
          ORA       M

          XRA       A
          XRA       B
          XRA       C
          XRA       D
          XRA       E
          XRA       H
          XRA       L
          XRI       MAX - 1
          XRA       M
          CMA

;--------------------------------------------------------------------
;  BIT OPERATION
;--------------------------------------------------------------------
          CMC
          STC

;--------------------------------------------------------------------
;  COMPARE
;--------------------------------------------------------------------
          CMP       A
          CMP       B
          CMP       C
          CMP       D
          CMP       E
          CMP       H
          CMP       L
          CPI       MAX - 1
          CMP       M

;--------------------------------------------------------------------
;  JUMP
;--------------------------------------------------------------------
          JMP       nn
          JNZ       nn + 1
          JZ        nn + 2
          JNC       nn + 3
          JC        nn + 4
          JPO       nn + 5
          JPE       nn + 6
          JP        nn + 7
          JM        nn + 8
          PCHL

;--------------------------------------------------------------------
;  CALL AND RETURN
;--------------------------------------------------------------------
          CALL      nn
          CNZ       nn + 1
          CZ        nn + 2
          CNC       nn + 3
          CC        nn + 4
          CPO       nn + 5
          CPE       nn + 6
          CP        nn + 7
          CM        nn + 8
          PCHL

          RET
          RNZ
          RZ
          RNC
          RC
          RPO
          RPE
          RP
          RM
          RST       0
          RST       1
          RST       2
          RST       3
          RST       4
          RST       5
          RST       6
          RST       7

;--------------------------------------------------------------------
;  CPU OPERATION AND INTERRUPT
;--------------------------------------------------------------------
          NOP
          HLT
          DI
          EI

;--------------------------------------------------------------------
;  I/O PORT INPUT/OUTPUT
;--------------------------------------------------------------------
          IN        MAX - 1
          OUT       MIN + 1

;--------------------------------------------------------------------
;  BCD
;--------------------------------------------------------------------
          DAA
